#include <stdio.h>
#include "swis.h"

#define TRUE            (1)
#define FALSE           (0)
#define CR              (13)
#define LF              (10)
#define UNUSED(k)       k=k

struct __FILE
{
        int handle;
};

FILE                    __stdout;
FILE                    __stdin;
static unsigned char    m_backspace = FALSE;

int fputc(int ch, FILE *f)
{
        static int      previous = 0;

        if ((ch == LF) && (previous != CR))
        {
                /* Expand isolated LF into CR+LF pair */
                _swi(OS_NewLine, 0);
        }
        else
        {
                /* Use OS_WriteC */
                _swi(OS_WriteC, _IN(0), ch);
        }

        previous = ch;
        UNUSED(f);

        return ch;
}

int fgetc(FILE *f)
{
        static int      previous = 0;

        if (m_backspace)
        {
                /* Return last */
                m_backspace = FALSE;
        }
        else
        {
                /* Get new from ReadC */
                _swi(OS_ReadC, _OUT(0), &previous);

                /* Echo to stdout accounting for carriage return */
                fputc(previous, stdout);
                if (previous == CR) fputc(LF, stdout);
        }

        UNUSED(f);

        return previous;
}

int __backspace(FILE *f)
{
        /* Log the backspace for next call to fgetc */
        m_backspace = TRUE;

        UNUSED(f);

        return 1;
}

int ferror(FILE *f)
{
        /* No errors thrown */
        UNUSED(f);

        return EOF;
}
