#include <sys/types.h>
#include <sys/stat.h>
#include "swis.h"

#define TRUE            (1)
#define FALSE           (0)
#define CR              (13)
#define LF              (10)
#define UNUSED(k)       k=k

int _write(int fd, const char *ptr, int len)
{
        int             count, ch;
        static int      previous = 0;

        for (count = 0; count < len; count++)
        {
                ch = ptr[count];
                if ((ch == LF) && (previous != CR))
                {
                        /* Expand isolated LF into CR+LF pair */
                        _swi(OS_NewLine, 0);
                }
                else
                {
                        /* Use OS_WriteC */
                        _swi(OS_WriteC, _IN(0), ch);
                }
                previous = ch;
        }

        UNUSED(fd);

        return len;
}

int _read(int fd, char *ptr, int len)
{
        int             ch;
        static int      previous = 0;

        /* Get new from ReadC */
        _swi(OS_ReadC, _OUT(0), &ch);
        *ptr = (char)ch;
        previous = ch;

        /* Echo to stdout accounting for carriage return */
        _swi(OS_WriteC, _IN(0), ch);
        if (previous == CR) _swi(OS_WriteI + LF, 0);

        /* Returns the actual number of bytes read */
        return 1;
}

int _lseek(int fd, int ptr, int dir)
{
        /* Seeking ignored */
        UNUSED(fd);
        UNUSED(ptr);
        UNUSED(dir);

        return 0;
}

int _close(int fd)
{
        UNUSED(fd);

        return -1;
}

int _isatty(int fd)
{
        /* Probably */
        return 1;
}

int _fstat(int fd, struct stat *st)
{
        /* Pretend to be character based */
        st->st_mode = S_IFCHR;

        return 0;
}
